Name:           vscodium
Version:        1.99.32562
Release:        5%{?dist}
Summary:        Free/Libre Open Source Software Binaries of VSCode

License:        MIT
URL:            https://github.com/VSCodium/vscodium
Source0:        %{url}/archive/refs/tags/%{version}.tar.gz
Source1:        vscodium.desktop

ExclusiveArch:  x86_64 aarch64

# Set VSCODE_ARCH based on the system architecture
%global vscode_arch x64
%ifarch aarch64
%global vscode_arch arm64
%endif

Requires:       libX11
Requires:       libxkbfile
Requires:       libsecret
Requires:       krb5-libs
Requires:       libstdc++
Requires:       ripgrep

BuildRequires:  nodejs-npm
BuildRequires:  rustup
BuildRequires:  ripgrep
BuildRequires:  jq
BuildRequires:  git
BuildRequires:  python3
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  pkgconf
BuildRequires:  libX11-devel
BuildRequires:  libxkbfile-devel
BuildRequires:  libsecret-devel
BuildRequires:  fakeroot
BuildRequires:  krb5-devel
BuildRequires:  rpm-build

%description
VSCodium is a community-driven, freely-licensed binary distribution of Microsoft’s VS Code. 
This package builds it from the official source using a reproducible process.

%prep
%autosetup -n %{name}-%{version}

%build
# Environment setup
export PATH=%{_bindir}:$PATH
export NODE_OPTIONS=--openssl-legacy-provider

export VSCODE_ARCH=%{vscode_arch}
export VSCODE_QUALITY="stable"
export RELEASE_VERSION="%{version}"
export SHOULD_BUILD="yes"
export SHOULD_BUILD_REH="no"
export CI_BUILD="no"
export OS_NAME="linux"
export DISABLE_UPDATE="yes"

# Rust setup
rustup-init -y
. "$HOME/.cargo/env"

# Build
sed -i "s#. version.sh#. ./version.sh#g" build.sh
sed -i "s#. prepare_vscode.sh#. ./prepare_vscode.sh#g" build.sh
. ./get_repo.sh
. ./build.sh

%install
mkdir -p %{buildroot}/usr/share/vscodium
cp -r VSCode-linux-%{vscode_arch}/* %{buildroot}/usr/share/vscodium/

# Replace statically included binary with system copy. It allows the usage of Fedora ripgrep binary that includes build-id
ln -sf /usr/bin/rg %{buildroot}/usr/share/vscodium/resources/app/node_modules/@vscode/ripgrep/bin/rg

# Symlink binary
mkdir -p %{buildroot}%{_bindir}
ln -s /usr/share/vscodium/bin/codium %{buildroot}%{_bindir}/codium

# Desktop entry
install -D -m644 %{SOURCE1} %{buildroot}%{_datadir}/applications/vscodium.desktop

# Icon
install -D -m644 VSCode-linux-%{vscode_arch}/resources/app/resources/linux/code.png \
  %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/vscodium.png

%files
%license LICENSE
%doc README.md
%{_bindir}/codium
%{_datadir}/vscodium
%{_datadir}/applications/vscodium.desktop
%{_datadir}/icons/hicolor/128x128/apps/vscodium.png

%changelog
* Sun Apr 21 2025 Little Owl <littleowl@athenaos.org> - 1.99.32562-1
- Initial RPM packaging for VSCodium with aarch64 support
